import java.io.*;
import java.util.Locale;

import com.gc.android.market.api.MarketSession;
import com.gc.android.market.api.MarketSession.Callback;
import com.gc.android.market.api.model.Market.AppsRequest;
import com.gc.android.market.api.model.Market.AppsResponse;
import com.gc.android.market.api.model.Market.ResponseContext;

public class getAppInfo {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO ꂽ\bhEX^u
		
		if(args.length < 5) {
			System.out.println("Usage :\n" +
					"java -jar this_jar_name email password query_str_file startIndex numbers [androidId]");
			return;
		}

		String email = args[0];
		String password = args[1];
		String query_str_filename = args[2];
		final int startIndex = Integer.parseInt(args[3]);
		final int numbers = Integer.parseInt(args[4]);
		String androidid = args.length > 5 ? args[5] : "0123012301230123";

		String query = "";
		try {
			BufferedReader inputStr = new BufferedReader(new FileReader(query_str_filename));  // ̓t@CJ
			query = inputStr.readLine();
		} catch (IOException e1) {
			// TODO ꂽ catch ubN
			System.out.println("readline error: " + e1.getMessage());
			System.exit(1);
		}

		System.out.println("query: " + query);

		MarketSession session = new MarketSession();
		session.getContext().setAndroidId(androidid);

		Locale locale = new Locale("ja","JP");
		session.setLocale(locale);
		session.setOperator("NTT DOCOMO", "44010");
		session.getContext().setDeviceAndSdkVersion("passion:8");

		try
		{
			session.login(email,password);
		} catch (Exception e) {
			System.out.println("Login Failed: " + e.getMessage());
			System.exit(1);
		}
		
		
		AppsRequest appsRequest = AppsRequest.newBuilder()
									.setQuery(query)
									.setStartIndex(startIndex)
									.setEntriesCount(numbers)
									.setWithExtendedInfo(true)
									.build();

		Callback<AppsResponse> callback = new Callback<AppsResponse> () {
				@Override
				public void onResult(ResponseContext context, AppsResponse response) {
					// TODO ꂽ\bhEX^u
					int totalcnt,cnt;
					if(response != null) {
						totalcnt = response.getEntriesCount();
						cnt = response.getAppCount();
						System.out.println("startIndex = " + startIndex);
						System.out.println("entriesCount = " + numbers);
						System.out.println("totalcount = " + totalcnt);
						System.out.println("count = " + cnt);
					} else {
						cnt = -1; 
					}
					if (cnt > 0) {
						for(int i = 0; ((i < cnt) && (i < numbers)); i++) {
							System.out.println("----------------------------------------------------------------------------------------");
							int counter = i + startIndex;
							System.out.println(counter + ":");
							System.out.println("----------------------------------------------------------------------------------------");
							System.out.println("title: " + response.getApp(i).getTitle());
							System.out.println("appType: " + response.getApp(i).getAppType());
							System.out.println("category: " + response.getApp(i).getExtendedInfo().getCategory());
							System.out.println("rating: " + response.getApp(i).getRating());
							System.out.println("ratingsCount: " + response.getApp(i).getRatingsCount());
							System.out.println("count: " + response.getApp(i).getExtendedInfo().getDownloadsCount());
							System.out.println("countText: " + response.getApp(i).getExtendedInfo().getDownloadsCountText());
							System.out.println("creator: " + response.getApp(i).getCreator());
							System.out.println("creatorId: " + response.getApp(i).getCreatorId());
							System.out.println("id: " + response.getApp(i).getId());
							System.out.println("packageName: " + response.getApp(i).getPackageName());
							System.out.println("version: " + response.getApp(i).getVersion());
							System.out.println("versionCode: " + response.getApp(i).getVersionCode());
							System.out.println("price: " + response.getApp(i).getPrice());
							System.out.println("priceMicros: " + response.getApp(i).getPriceMicros());
							System.out.println("priceCurrency: " + response.getApp(i).getPriceCurrency());
							System.out.println("contactEmail: " + response.getApp(i).getExtendedInfo().getContactEmail());
							System.out.println("contactPhone: " + response.getApp(i).getExtendedInfo().getContactPhone());
							System.out.println("contactWebsite: " + response.getApp(i).getExtendedInfo().getContactWebsite());
							System.out.println("screenshotsCount: " + response.getApp(i).getExtendedInfo().getScreenshotsCount());
							System.out.println("installSize: " + response.getApp(i).getExtendedInfo().getInstallSize());
							System.out.println("permissionIdList: " + response.getApp(i).getExtendedInfo().getPermissionIdList());
							System.out.println("promotoText: " + response.getApp(i).getExtendedInfo().getPromoText());
							System.out.println("description: " + response.getApp(i).getExtendedInfo().getDescription());
						}
					} else if (cnt == 0) {
						System.out.println("no hit");
					} else {
						System.out.println("Bad Reqeust");
					}
				}
		};
		session.append(appsRequest, callback);
		session.flush();
	}
}
